<?php

namespace Lucent\Record;

use Illuminate\Support\Facades\DB;

class RecordRepo
{
    public function __construct()
    {
    }

    public static function create(Record $record): void
    {
        $recordToDB = $record->toDB();

        DB::table("records")->insert($recordToDB);

    }

    /**
     * @param array<string> $ids
     */
    public static function updateStatusBulk(Status $status, array $ids): void
    {
        DB::table("records")->whereIn("id", $ids)->update([
            'status' => $status->value
        ]);
    }

    public static function update(Record $record): void
    {

        $recordToDB = $record->toDB();
        DB::table("records")->where("id", $record->id)->update($recordToDB);
    }


    /**
     * @param string[] $ids
     */
    public function deleteMany(
        array $ids,
    ): void
    {

        DB::table("records")->whereIn("id", $ids)->delete();
        DB::table("edges")->whereIn("source", $ids)->delete();
        DB::table("edges")->whereIn("target", $ids)->delete();
        DB::table("revisions")->whereIn("recordId", $ids)->delete();
    }

    public function deleteTrashedBySchema(
        string $schemaName,
    ): void
    {
        $ids = DB::table("records")
            ->where("schema", $schemaName)
            ->where("status", Status::TRASHED->value)
            ->get()->pluck("id")->toArray();

        $this->deleteMany($ids);
    }
}
